unit WinBackupConfigUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Proc,DateUtils;

type
  TWinBackupConfig = class(TForm)
    Panel1: TPanel;
    Label2: TLabel;
    FileName: TEdit;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    secCount: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    procedure WaitForOk;
  public
    { Public declarations }
  end;

var
  WinBackupConfig: TWinBackupConfig;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinBackupConfig.FormCreate(Sender: TObject);
begin
  //
end;

procedure TWinBackupConfig.FormDestroy(Sender: TObject);
begin
 WinBackupConfig := nil;
end;

procedure TWinBackupConfig.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;


procedure TWinBackupConfig.WaitForOk;
var
   s: string;
   ts: TDateTime;
begin
   ts:=now;
      while true do begin
        if MilliSecondsBetween(Now,ts) > 1000 then break;
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
        end;
      end;

end;


procedure TWinBackupConfig.BitBtn1Click(Sender: TObject);
var
  s,k,v,sn: string;
  i,p: integer;
  f: TFileStream;
begin
  if Length(FileName.Text)>0 then begin
    if FileExists(FileName.Text) then
      f:= TFileStream.Create(FileName.Text, fmOpenReadWrite	 or fmShareDenyNone )
    else
      f:= TFileStream.Create(FileName.Text, fmCreate or fmShareDenyNone	 );
    try
      f.Size:=0;
      secCount.Caption:='0';
      secCount.Visible:=true;
      Label4.Visible:=true;
      i:=1;
      MainForm.ClearInput;
      MainForm.AddToOutput('cat stab'+#13#10);

      s:='##### BEGIN STAB #####'+#13#10;
      f.Write(s[1],Length(s));

      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;

      s:='##### END STAB #####'+#13#10;
      f.Write(s[1],Length(s));


      MainForm.ClearInput;
      MainForm.AddToOutput('cat wp'+#13#10);
      s:='##### BEGIN WP #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          if Pos(':',s)=0 then continue;
          if Pos('Waypoints',s)>0 then continue;
          if Pos('latitude',s)>0 then continue;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          v:='';
          p:=pos(':',s);
          k:=Copy(s,1,p-1);
          v:='set wp '+k+' '; //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(',',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       // 
          delete(s,1,p);
          s:=trim(s);

          p:=pos(',',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';      // 
          delete(s,1,p);
          s:=trim(s);


          s:=v+s;    //  
          s:=s+#13#10;
          f.Write(s[1],Length(s));

        end;
      end;

      s:='##### END WP #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat osd'+#13#10);
      s:='##### BEGIN OSD #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             v:=StringReplace(v,',',' ',[rfReplaceAll]);
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;

      s:='##### END OSD #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat imu'+#13#10);

      s:='##### BEGIN IMU #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END IMU #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat adc_settings'+#13#10);
      s:='##### BEGIN ADC_SETTINGS #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END ADC_SETTINGS #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat batteries'+#13#10);
      s:='##### BEGIN BATTERIES #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END BATTERIES #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat gyro'+#13#10);
      s:='##### BEGIN GYRO #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END GYRO #####'+#13#10;
      f.Write(s[1],Length(s));

      sleep(500);


      MainForm.ClearInput;
      MainForm.AddToOutput('cat mag'+#13#10);
      s:='##### BEGIN MAG #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          if ExtractKeyValue(s,k,v) then begin
             s:='set '+k+' '+v;
          end else continue;
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END MAG #####'+#13#10;
      f.Write(s[1],Length(s));


{
Receiver_Mode=1
#       type    ch_N    min     center      max
0:	1	3	1160	1500	1855
1:	2	1	1136	1509	1866
2:	3	1	1136	1509	1866
3:	4	2	1176	1527	1868
4:	5	4	1155	1524	1886
5:	10	5	1100	1137	1200
6:	11	5	1400	1500	159
}
      MainForm.ClearInput;
      MainForm.AddToOutput('cat control in'+#13#10);
      s:='##### BEGIN CONTROL IN #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          s:=StringReplace(s,#9,' ',[rfReplaceAll]);
          if Pos('type',s)>0 then continue;
          if Pos('=',s)>0 then continue;
          if Pos(':',s)=0 then continue;
          v:='';
          p:=pos(':',s);
          k:=Copy(s,1,p-1);
          v:='set ch_in '+k+' '; //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       //  
          delete(s,1,p);
          s:=trim(s);


          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       // 
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       // 
          delete(s,1,p);
          s:=trim(s);

          s:=v+s;    //  

          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END CONTROL IN #####'+#13#10;
      f.Write(s[1],Length(s));

      MainForm.ClearInput;
      MainForm.AddToOutput('cat control out'+#13#10);
      s:='##### BEGIN CONTROL OUT #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          s:=StringReplace(s,#9,' ',[rfReplaceAll]);
          if Pos('type',s)>0 then continue;
          if Pos('=',s)>0 then continue;
          if Pos(':',s)=0 then continue;
          v:='';
          p:=pos(':',s);
          k:=Copy(s,1,p-1);
          v:='set ch_out '+k+' '; //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       //  
          delete(s,1,p);
          s:=trim(s);


          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       // 
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=v+k+' ';       // 
          delete(s,1,p);
          s:=trim(s);

          s:=v+s;    //  

          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
      s:='##### END CONTROL OUT #####'+#13#10;
      f.Write(s[1],Length(s));
{
Mixers_Allowed=0
Output MIXERS configuration:
Out Type  1    2    3    4    5
1:       100  0    0    0    0
2:       0    100  0    0    0
3:       0    0    100  0    0
4:       0    0    0    100  0
5:       0    0    0    0    100
6:       50   -14  0    0    0
7:       0    0    0    0    0
8:       0    0    0    0    0
9:       0    0    0    0    0
}

      MainForm.ClearInput;
      MainForm.AddToOutput('cat control mixers'+#13#10);
      s:='##### BEGIN CONTROL MIXERS #####'+#13#10;
      f.Write(s[1],Length(s));
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          secCount.Caption:=IntToStr(i);
          s:=StringReplace(s,#9,' ',[rfReplaceAll]);
          if Pos('Type',s)>0 then continue;
          if Pos('MIXERS',s)>0 then continue;
          if Pos('=',s)>0 then continue;
          if Pos(':',s)=0 then continue;
          v:='';
          p:=pos(':',s);
          sn:=Copy(s,1,p-1);

          if sn = '1' then continue;
          if sn = '2' then continue;
          if sn = '3' then continue;
          if sn = '4' then continue;
          if sn = '5' then continue;
          if sn = '6' then continue;
          if sn = '7' then continue;
          if sn = '8' then continue;
          if sn = '9' then continue;

          sn:='set mix '+sn+' '; //  
          delete(s,1,p);
          s:=trim(s);

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'1 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'2 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'3 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'4 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));


          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'5 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'6 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'7 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));

          p:=pos(' ',s);
          k:=Trim(Copy(s,1,p-1));
          v:=sn+'8 '+k+#13#10;       //   
          delete(s,1,p);
          s:=trim(s);
          f.Write(v[1],Length(v));


          v:=sn+'9 '+s+#13#10;       //   
          f.Write(v[1],Length(v));


        end;
      end;
      s:='##### END CONTROL MIXERS #####'+#13#10;
      f.Write(s[1],Length(s));


    finally
      f.Free;
    end;
    secCount.Visible:=false;
    Label4.Visible:=false;
    Application.ProcessMessages;
    ShowMessage('  ');
  end else begin
     ShowMessage('    ');
  end;
end;

procedure TWinBackupConfig.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinBackupConfig.SpeedButton1Click(Sender: TObject);
begin
  if SaveDialog1.Execute then begin
     FileName.Text:=SaveDialog1.FileName;
  end;
end;

end.
