unit WinControlPointsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc, Mask;

type
  TWinControlPoints = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label2: TLabel;
    Wp_Lat_0: TEdit;
    Wp_Lon_0: TEdit;
    Wp_Alt_0: TEdit;
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Wp_Lat_1: TEdit;
    Wp_Lon_1: TEdit;
    Wp_Alt_1: TEdit;
    Label7: TLabel;
    Wp_Lat_2: TEdit;
    Wp_Lon_2: TEdit;
    Wp_Alt_2: TEdit;
    Label8: TLabel;
    Wp_Lat_3: TEdit;
    Wp_Lon_3: TEdit;
    Wp_Alt_3: TEdit;
    Label9: TLabel;
    Wp_Lat_4: TEdit;
    Wp_Lon_4: TEdit;
    Wp_Alt_4: TEdit;
    Label10: TLabel;
    Wp_Lat_5: TEdit;
    Wp_Lon_5: TEdit;
    Wp_Alt_5: TEdit;
    Label11: TLabel;
    Wp_Lat_6: TEdit;
    Wp_Lon_6: TEdit;
    Wp_Alt_6: TEdit;
    Label12: TLabel;
    Wp_Lat_7: TEdit;
    Wp_Lon_7: TEdit;
    Wp_Alt_7: TEdit;
    Label13: TLabel;
    Wp_Lat_8: TEdit;
    Wp_Lon_8: TEdit;
    Wp_Alt_8: TEdit;
    Label14: TLabel;
    Wp_Lat_9: TEdit;
    Wp_Lon_9: TEdit;
    Wp_Alt_9: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      InitValues: TStringList;
      procedure LoadVariable(k,v: string);
      procedure SetControlValue(tc: TControl; v: string);

      procedure SetWpControlValue(c_Num, c_Lat, c_Lon,  c_Alt: string);

      function  GetControlValue(tc: TControl): string;
      function  FindControl(cn: string): TControl; 
      procedure ApplyChanges;

  end;

var
  WinControlPoints: TWinControlPoints;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinControlPoints.FormCreate(Sender: TObject);
var
      s,k,v: string;
      c_Num, c_Alt,c_Lat,c_Lon: string;
      i: integer;
begin
  InitValues:= TStringList.Create;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat wp'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else begin
//  0: 0.00000, 0.00000, 0
//  1: 0.00000, 0.00000, 0

        s:=StringReplace(s,#9,' ',[rfReplaceAll]);
        if s[1]='#' then continue; //  
        i:=pos(':',s);
        if i=0 then continue; //  
        //  
        c_Num:=Copy(s,1,i-1);
        Delete(s,1,i);
        s:=Trim(s);
        // 
        i:=pos(',',s);
        if i=0 then continue;
        c_Lat:=Copy(s,1,i-1);
        Delete(s,1,i);
        s:=Trim(s);
        // 
        i:=pos(',',s);
        if i=0 then continue;
        c_Lon:=Copy(s,1,i-1);
        Delete(s,1,i);
        s:=Trim(s);
        c_Alt:=s;

        
        SetWpControlValue(c_Num, c_Lat, c_Lon,  c_Alt);




      end;
    end;
  end;
end;

procedure TWinControlPoints.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Action := caFree;
end;



procedure TWinControlPoints.ApplyChanges;
var
  i: integer;
  k,v: string;
  tc: TControl;
  ControlName: string;
  new_Lat, new_Lon, new_Alt: string;
  doChange: boolean;
begin
  for i:=0 to 9 do begin

    doChange:=false;

    k:='Wp_Lat_'+IntToStr(i);
    v:=InitValues.Values[k];
    tc:=FindControl(k);
    if(tc = nil) then exit;
    new_Lat:=GetControlValue(tc);
    if new_Lat <> v then doChange:=true;
    InitValues.Values[k]:=new_Lat;

    k:='Wp_Lon_'+IntToStr(i);
    v:=InitValues.Values[k];
    tc:=FindControl(k);
    if(tc = nil) then exit;
    new_Lon:=GetControlValue(tc);
    if new_Lon <> v then doChange:=true;
    InitValues.Values[k]:=new_Lon;

    k:='Wp_Alt_'+IntToStr(i);
    v:=InitValues.Values[k];
    tc:=FindControl(k);
    if(tc = nil) then exit;
    new_Alt:=GetControlValue(tc);
    if new_Alt <> v then doChange:=true;
    InitValues.Values[k]:=new_Alt;

    
    if doChange then MainForm.AddToOutput('set wp '+IntToStr(i)+' '+new_Lat+' '+new_Lon+' '+new_Alt +#13#10);
    doChange := false;

  end;
end;


function TWinControlPoints.FindControl(cn: string): TControl;
begin
    Result:=Panel2.FindChildControl(cn);
    if Result = nil then begin
      exit;
    end;
end;


function TWinControlPoints.GetControlValue(tc: TControl): string;
begin

  Result:='';
  if tc.ClassName='TEdit' then begin
     Result:=(tc as TEdit).Text;
     Result:=StringReplace(Result,',','.',[rfReplaceAll]);
  end;
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;

  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;

  if tc.ClassName='TCheckBox' then begin
     Result:='0';
     if (tc as TCheckBox).Checked then Result:='1';
  end;

end;


procedure TWinControlPoints.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  tc:=FindControl(k);
  if(tc<>nil) then begin
    SetControlValue(tc,v);
    InitValues.Values[k]:=v;
  end;
end;

procedure TWinControlPoints.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TEdit' then begin
     (tc as TEdit).Text := v;
  end;


  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;

  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;

  if tc.ClassName='TCheckBox' then begin
     if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
  end;
end;



procedure TWinControlPoints.BitBtn3Click(Sender: TObject);
begin
   ApplyChanges;
end;

procedure TWinControlPoints.BitBtn1Click(Sender: TObject);
begin
   ApplyChanges;
   Close;
end;

procedure TWinControlPoints.SetWpControlValue(c_Num, c_Lat, c_Lon, c_Alt: string);
var
  tc: TControl;
  ControlName : string;
begin
  ControlName:='Wp_Lat_'+c_Num;
  tc := FindControl(ControlName);
  if tc = nil then exit;
  InitValues.Values[ControlName]:=c_Lat;
  c_Lat:=StringReplace(c_Lat,'.',',',[rfReplaceAll]);
  SetControlValue(tc,c_Lat);



  ControlName:='Wp_Lon_'+c_Num;
  tc := FindControl(ControlName);
  if tc = nil then exit;
  InitValues.Values[ControlName]:=c_Lon;
  c_Lon:=StringReplace(c_Lon,'.',',',[rfReplaceAll]);
  SetControlValue(tc,c_Lon);

  ControlName:='Wp_Alt_'+c_Num;
  tc := FindControl(ControlName);
  if tc = nil then exit;
  InitValues.Values[ControlName]:=c_Alt;
  c_Alt:=StringReplace(c_Alt,'.',',',[rfReplaceAll]);
  SetControlValue(tc,c_Alt);


end;

procedure TWinControlPoints.FormDestroy(Sender: TObject);
begin
  InitValues.Free;
  WinControlPoints := nil;

end;

end.
