unit WinExportLogsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls, Proc;

type
  TWinExportLogs = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    FlightNumber: TComboBox;
    Label2: TLabel;
    FileName: TEdit;
    SpeedButton1: TSpeedButton;
    Label3: TLabel;
    SaveDialog1: TSaveDialog;
    Label4: TLabel;
    secCount: TLabel;
    ReplacePoints: TCheckBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Flight_Id_Min: integer;
    Flight_Id_Max: integer;
  end;

var
  WinExportLogs: TWinExportLogs;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinExportLogs.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TWinExportLogs.FormDestroy(Sender: TObject);
begin
  WinExportLogs := nil;
end;

procedure TWinExportLogs.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinExportLogs.BitBtn1Click(Sender: TObject);
var
  s,k,v: string;
  i: integer;
  f: TFileStream;
begin
  if Length(FileName.Text)>0 then begin
    if FileExists(FileName.Text) then
      f:= TFileStream.Create(FileName.Text, fmOpenReadWrite	 or fmShareDenyNone )
    else
      f:= TFileStream.Create(FileName.Text, fmCreate or fmShareDenyNone	 );
    try
      secCount.Caption:='0';
      secCount.Visible:=true;
      Label4.Visible:=true;
      MainForm.ClearInput;
      MainForm.AddToOutput('log dump '+IntToStr(Flight_Id_Max - FlightNumber.ItemIndex)+#13#10);
      i:=1;
      while true do begin
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then break;
          i:=i+1;
          if ReplacePoints.Checked then s := StringReplace(s,'.',',',[rfReplaceAll]);
          // dumping
          secCount.Caption:=IntToStr(i);
          s:=s+#13#10;
          f.Write(s[1],Length(s));
        end;
      end;
    finally
      f.Free;
    end;
    secCount.Visible:=false;
    Label4.Visible:=false;
    Application.ProcessMessages;
    ShowMessage(' ');
  end else begin
     ShowMessage('    ');
  end;
end;

procedure TWinExportLogs.SpeedButton1Click(Sender: TObject);
var
   fn: string;
begin
  if SaveDialog1.Execute then begin
     FileName.Text:=SaveDialog1.FileName;
  end;
end;

procedure TWinExportLogs.FormCreate(Sender: TObject);
var
  s,k,v: string;
  i: integer;
begin
  MainForm.ClearInput;
  MainForm.AddToOutput('log dir'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        if k='flight_id_min' then Flight_Id_Min:=StrToInt(v);
        if k='flight_id_max' then Flight_Id_Max:=StrToInt(v);
      end else continue;
    end;
  end;

  for i:=Flight_Id_Max downto Flight_Id_Min do begin
     FlightNumber.Items.Add('  '+IntToStr(i))
  end;

  FlightNumber.ItemIndex:=0;
end;

end.
