unit WinImuSettingsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc, Mask, DateUtils;

type
  TWinImuSettings = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    BitBtn3: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Label2: TLabel;
    EKF_Proc_Variance: TEdit;
    EKF_Accel_Variance: TEdit;
    Label111: TLabel;
    EKF_Mag_Variance: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    EKF_Accel_Gravity_Cut_Off: TEdit;
    EKF_Gyro_Freq_Fir: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    EKF_Accel_Freq_Fir: TEdit;
    EKF_Mag_Freq_Fir: TEdit;
    Label7: TLabel;
    EKF_Gyro_Use_Fir: TCheckBox;
    EKF_Accel_Use_Fir: TCheckBox;
    EKF_Mag_Use_Fir: TCheckBox;
    Label8: TLabel;
    Accel_Compens_X_K: TEdit;
    Accel_Compens_YR_K_0_5: TEdit;
    Label9: TLabel;
    Label11: TLabel;
    Accel_Compens_YR_K_5_10: TEdit;
    Accel_Compens_YR_K_10_15: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Accel_Compens_YR_K_15_100: TEdit;
    Accel_Compens_Z_K: TEdit;
    Label10: TLabel;
    TabSheet3: TTabSheet;
    SpeedButton2: TSpeedButton;
    Label14: TLabel;
    Accel_ref_x: TEdit;
    Label15: TLabel;
    Accel_ref_y: TEdit;
    Label16: TLabel;
    Accel_ref_z: TEdit;
    Label17: TLabel;
    Mag_ref_x: TEdit;
    Label18: TLabel;
    Mag_ref_y: TEdit;
    Label19: TLabel;
    Mag_ref_z: TEdit;
    Label20: TLabel;
    Trimmer_Roll: TEdit;
    Label21: TLabel;
    Label22: TLabel;
    Trimmer_Pitch: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Accel_Compens_YL_K_0_5: TEdit;
    Accel_Compens_YL_K_5_10: TEdit;
    Accel_Compens_YL_K_10_15: TEdit;
    Accel_Compens_YL_K_15_100: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
      InitValues: TStringList;
      procedure LoadVariable(k,v: string);
      procedure SetControlValue(tc: TControl; v: string);
      function  GetControlValue(tc: TControl): string;
      function  FindControl(cn: string): TControl;
      procedure ApplyChanges;
      procedure WaitForOk;
  end;

var
  WinImuSettings: TWinImuSettings;

implementation

{$R *.dfm}

uses Main;

procedure TWinImuSettings.FormDestroy(Sender: TObject);
begin
  InitValues.Free;
  WinImuSettings:=nil;
end;

procedure TWinImuSettings.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caFree;
end;

procedure TWinImuSettings.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  tc:=FindControl(k);
  if(tc<>nil) then begin
    SetControlValue(tc,v);
    InitValues.Values[k]:=v;
  end;
end;

function TWinImuSettings.GetControlValue(tc: TControl): string;
begin
  Result:='';
  if tc.ClassName='TEdit' then begin
     Result:=(tc as TEdit).Text;
     Result:=StringReplace(Result,',','.',[rfReplaceAll]);
  end;
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;
  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;
  if tc.ClassName='TCheckBox' then begin
     Result:='0';
     if (tc as TCheckBox).Checked then Result:='1';
  end;
end;

function TWinImuSettings.FindControl(cn: string): TControl;
begin
  Result:=TabSheet1.FindChildControl(cn);
  if Result = nil then begin
    Result:=TabSheet2.FindChildControl(cn);
    if Result = nil then begin
       Result:=TabSheet3.FindChildControl(cn);
    end;
  end;
end;

procedure TWinImuSettings.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TEdit' then begin
     (tc as TEdit).Text := v;
  end;
  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;
  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;
  if tc.ClassName='TCheckBox' then begin
     if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
  end;
end;


procedure TWinImuSettings.BitBtn1Click(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;

procedure TWinImuSettings.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinImuSettings.FormCreate(Sender: TObject);
var
  s,k,v: string;
begin
  if InitValues=nil then InitValues:= TStringList.Create;
  InitValues.Clear;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat imu'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else continue;
    end;
  end;
end;

procedure TWinImuSettings.SpeedButton2Click(Sender: TObject);
begin
    MainForm.ClearInput;
    MainForm.AddToOutput('save ref'+#13#10);
end;

procedure TWinImuSettings.SpeedButton1Click(Sender: TObject);
begin
    MainForm.ClearInput;
    MainForm.AddToOutput('reset imu'+#13#10);
    WaitForOk;
    FormCreate(Sender);
end;

procedure TWinImuSettings.ApplyChanges;
var
  i: integer;
  k,v: string;
   tc,tc_x,tc_y: TControl;
   ControlName: string;
   new_v,x,y,new_xv,new_yv: string;
begin
  for i:=0 to InitValues.Count-1 do begin
    k:=InitValues.Names[i];
    v:=InitValues.ValueFromIndex[i];
    tc:=FindControl(k);
    if(tc<>nil) then begin
      new_v:=GetControlValue(tc);
      if (new_v<>'') and (new_v <> v) then begin
         MainForm.AddToOutput('set '+k+' '+ new_v +#13#10);
         InitValues.Values[k]:=new_v;
      end;
    end;
  end;
end;



procedure TWinImuSettings.BitBtn3Click(Sender: TObject);
begin
  ApplyChanges;
end;


procedure TWinImuSettings.WaitForOk;
var
   s: string;
   ts: TDateTime;
begin
   ts:=now;
      while true do begin
        if MilliSecondsBetween(Now,ts) > 3000 then break;
        Application.ProcessMessages;
        s:=MainForm.GetNextInputString;
        if s<>'' then begin
          if s='=>' then begin
//             ShowMessage(s);
             break;
          end;
        end;
      end;

end;


end.
