unit WinSimFlightGearUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdUDPBase, IdUDPServer, StdCtrls,
  Buttons, ExtCtrls, IdSocketHandle, IdUDPClient;

type
  TWinSimFlightGear = class(TForm)
    Label1: TLabel;
    Panel1: TPanel;
    BitBtn2: TBitBtn;
    BitBtn1: TBitBtn;
    IdUDPServer1: TIdUDPServer;
    Panel2: TPanel;
    Button1: TButton;
    Label2: TLabel;
    OutCounterText: TLabel;
    Timer1: TTimer;
    OutCount: TLabel;
    InputCount: TLabel;
    IdUDPClient1: TIdUDPClient;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IdUDPServer1UDPRead(Sender: TObject; AData: TStream;  ABinding: TIdSocketHandle);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    outCounter: integer;
  end;

var
  WinSimFlightGear: TWinSimFlightGear;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinSimFlightGear.FormClose(Sender: TObject;  var Action: TCloseAction);
begin
   Action := caFree;
end;

procedure TWinSimFlightGear.IdUDPServer1UDPRead(Sender: TObject; AData: TStream; ABinding: TIdSocketHandle);
var
   s : string;
   i,j: integer;
begin
   SetLength(s,AData.Size);
   Adata.Read(s[1],AData.Size);

   if s<>'' then begin
     s:=trim(s)+#13#10;

     if MainForm.GetOutputCount < 100 then begin
        MainForm.AddToOutput(s);
     end;
     outCounter := outCounter+ 1;
     OutCounterText.Caption:=IntToStr(outCounter);


     i:=MainForm.GetOutputCount;
     OutCount.Caption:=IntToStr(i);
     j:=MainForm.GetInputCount;
     InputCount.Caption:=IntToStr(j);
   end;


   while true do begin
      s:=Trim(MainForm.GetNextInputString);
      if s='' then break;
      s:=s+#13#10;
      IdUDPClient1.Send(s);
   end;


end;

procedure TWinSimFlightGear.Button1Click(Sender: TObject);
begin
  IdUDPServer1.Active:=false;
  IdUDPClient1.Active:=false;
  MainForm.AddToOutput('stopsim'+#13#10);
end;

procedure TWinSimFlightGear.BitBtn1Click(Sender: TObject);
begin
  outCounter:=0;
  MainForm.AddToOutput('startsim flightgear'+#13#10);
  IdUDPServer1.Active:=true;
  IdUDPClient1.Active:=true;
//  Timer1.Enabled:=true;
end;

procedure TWinSimFlightGear.BitBtn2Click(Sender: TObject);
begin
  Button1Click(Sender);
  Close;
end;

procedure TWinSimFlightGear.FormDestroy(Sender: TObject);
begin
  IdUDPServer1.Active:=false;
end;

procedure TWinSimFlightGear.Timer1Timer(Sender: TObject);
var
   s : string;
begin

   s :='1.1;1.1;1.1;1.1;1.1;1.1;1.1;1.1;1.1;1.1;1.1;1.1';
   if s<>'' then begin
     s:=trim(s)+#13#10;
     MainForm.AddToOutput(s);
     outCounter := outCounter+ 1;
     OutCounterText.Caption:=IntToStr(outCounter);
   end;


   while true do begin
    s:=MainForm.GetNextInputString;
    if s='' then break;
   end;


end;

end.
