unit WinStabControlUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls, Proc, Mask;

type
  TWinStabControl = class(TForm)
    Panel2: TPanel;
    Label1: TLabel;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Board_Reverse_Pitch: TCheckBox;
    Board_Reverse_Roll: TCheckBox;
    Board_Reverse_Yaw: TCheckBox;
    GroupBox2: TGroupBox;
    Servo_Reverse_Pitch_Out: TCheckBox;
    Servo_Reverse_Roll_Right_Out: TCheckBox;
    Servo_Reverse_Yaw_Out: TCheckBox;
    GroupBox3: TGroupBox;
    Stick_Reverse_Pitch: TCheckBox;
    Stick_Reverse_Roll: TCheckBox;
    Stick_Reverse_Yaw: TCheckBox;
    Servo_Reverse_Roll_Left_Out: TCheckBox;
    Label2: TLabel;
    V_Min_1: TEdit;
    GAZ_minimum: TUpDown;
    Label3: TLabel;
    Edit1: TEdit;
    GAZ_Cruise: TUpDown;
    Label4: TLabel;
    Edit2: TEdit;
    GAZ_maximum: TUpDown;
    TabSheet3: TTabSheet;
    Label5: TLabel;
    GAZ_Cruise_delta: TEdit;
    Label6: TLabel;
    Baro_Altitude_InAir_Border: TEdit;
    Label7: TLabel;
    Home_Point_alt: TEdit;
    Label8: TLabel;
    Roll_Sensitivity: TEdit;
    Label9: TLabel;
    Pitch_Sensitivity: TEdit;
    Label10: TLabel;
    Yaw_Sensitivity: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Koef_Omega_Yaw: TEdit;
    Koef_Omega_Pitch: TEdit;
    Koef_Omega_Roll: TEdit;
    Label19: TLabel;
    Take_Altitude_Max_Angles: TEdit;
    Label20: TLabel;
    Kurs_Roll_To_Pitch_Koef: TEdit;
    Label21: TLabel;
    Take_Kurs_Roll_Max_Angles: TEdit;
    Label22: TLabel;
    Nav_Critical_Altitude_Low_Border: TEdit;
    Label23: TLabel;
    Nav_Critical_Altitude_Upper_Border: TEdit;
    Label24: TLabel;
    Target_Reached_Radius: TEdit;
    Label25: TLabel;
    Target_Altitude_Corridor: TEdit;
    Label26: TLabel;
    Soft_Kurs_Keeping_Border: TEdit;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Auto_Trim_Max_Values: TEdit;
    Label36: TLabel;
    Label37: TLabel;
    Adaptive_Roll_Brake_Period: TEdit;
    Label38: TLabel;
    Label39: TLabel;
    Low_Critical_Speed: TEdit;
    Label40: TLabel;
    Label41: TLabel;
    Upper_Critical_Speed: TEdit;
    Label42: TLabel;
    Label43: TLabel;
    Turn_Damp_Amplifier: TEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Yaw_Position_Stick_Max: TEdit;
    Pitch_Position_Stick_Max: TEdit;
    Roll_Position_Stick_Max: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    Roll_Position_Danger: TEdit;
    Pitch_Position_Danger: TEdit;
    Flight_Logs_Allowed: TCheckBox;
    TabSheet4: TTabSheet;
    Label44: TLabel;
    Test_Alt: TEdit;
    Nav_Test_Mode: TCheckBox;
    Label45: TLabel;
    Current_Autopilot_Mode: TComboBox;
    Label46: TLabel;
    Label47: TLabel;
    Test_Alt_Spd: TEdit;
    Label49: TLabel;
    Label48: TLabel;
    Test_Lat: TEdit;
    Label50: TLabel;
    Test_Lon: TEdit;
    Label51: TLabel;
    Test_Aileron: TEdit;
    Label52: TLabel;
    Test_Elevator: TEdit;
    Label53: TLabel;
    Test_Ruder: TEdit;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Mag_Real_Heading_Delta: TEdit;
    Label58: TLabel;
    TabSheet5: TTabSheet;
    GroupBox4: TGroupBox;
    Label59: TLabel;
    MainBattery_Warning_Type: TComboBox;
    MainBattery_Warning_Level: TEdit;
    Label60: TLabel;
    GroupBox5: TGroupBox;
    Label61: TLabel;
    Altitude_Warning_Level: TEdit;
    GroupBox6: TGroupBox;
    Label62: TLabel;
    Speed_Warning_Type: TComboBox;
    Label63: TLabel;
    Speed_Warning_Level_Min: TEdit;
    Label64: TLabel;
    Speed_Warning_Level_Max: TEdit;
    Label65: TLabel;
    Low_Yellow_Zone_Speed: TEdit;
    Label66: TLabel;
    Label68: TLabel;
    Upper_Yellow_Zone_Speed: TEdit;
    Allow_Air_Sensor_For_Speed_Control: TCheckBox;
    Label67: TLabel;
    Label69: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    InitValues: TStringList; 
    procedure ApplyChanges;
    function FindControl(cn: string): TControl;
    function GetControlValue(tc: TControl): string;
    procedure LoadVariable(k, v: string);
    procedure SetControlValue(tc: TControl; v: string);
  end;

var
  WinStabControl: TWinStabControl;

implementation

uses MAIN;

{$R *.dfm}

procedure TWinStabControl.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   Action:=caFree;
end;

procedure TWinStabControl.FormDestroy(Sender: TObject);
begin
  InitValues.Free;
  WinStabControl:=nil;
end;

procedure TWinStabControl.FormCreate(Sender: TObject);
var
  s,k,v: string;
begin
  InitValues:= TStringList.Create;
  MainForm.ClearInput;
  MainForm.AddToOutput('cat stab'+#13#10);
  while true do begin
    s:=MainForm.GetNextInputString;
    if s<>'' then begin
      if s='=>' then break;
      if ExtractKeyValue(s,k,v) then begin
        LoadVariable(k,v);
      end else continue;
    end;
  end;
end;


procedure TWinStabControl.ApplyChanges;
var
  i: integer;
  k,v: string;
   tc,tc_x,tc_y: TControl;
   ControlName: string;
   new_v,x,y,new_xv,new_yv: string;
begin
  for i:=0 to InitValues.Count-1 do begin
    k:=InitValues.Names[i];
    v:=InitValues.ValueFromIndex[i];
    tc:=FindControl(k);
    if(tc<>nil) then begin
      new_v:=GetControlValue(tc);
      if (new_v<>'') and (new_v <> v) then begin
         MainForm.AddToOutput('set '+k+' '+ new_v +#13#10);
         InitValues.Values[k]:=new_v;
      end;
    end;
  end;
end;

function TWinStabControl.FindControl(cn: string): TControl;
begin
  Result:=TabSheet1.FindChildControl(cn);
  if Result = nil then begin
    Result:=TabSheet2.FindChildControl(cn);
    if Result = nil then begin
       Result:=GroupBox1.FindChildControl(cn);
       if Result = nil then begin
         Result:=GroupBox2.FindChildControl(cn);
         if Result = nil then begin
            Result:=GroupBox3.FindChildControl(cn);
            if Result = nil then begin
              Result:=TabSheet3.FindChildControl(cn);
              if Result = nil then begin
                 Result:=TabSheet4.FindChildControl(cn);
                 if Result = nil then begin
                   Result:=GroupBox4.FindChildControl(cn);
                   if Result = nil then begin
                      Result:=GroupBox5.FindChildControl(cn);
                      if Result = nil then begin
                        Result:=GroupBox6.FindChildControl(cn);
                        if Result = nil then  exit;
                      end;
                   end;
                 end;
              end;
            end;
         end;
       end;
    end;
  end;
end;

function TWinStabControl.GetControlValue(tc: TControl): string;
begin
  Result:='';
  if tc.ClassName='TEdit' then begin
     Result:=(tc as TEdit).Text;
     Result:=StringReplace(Result,',','.',[rfReplaceAll]);
  end;
  if tc.ClassName='TComboBox' then begin
     Result:=IntToStr((tc as TComboBox).ItemIndex);
  end;
  if tc.ClassName='TUpDown' then begin
     Result:=IntToStr((tc as TUpDown).Position)
  end;
  if tc.ClassName='TCheckBox' then begin
     if tc.Tag = 0 then begin
       Result:='0';
       if (tc as TCheckBox).Checked then Result:='1';
     end else begin
       Result:='1';
       if (tc as TCheckBox).Checked then Result:='-1';
     end;
  end;
end;

procedure TWinStabControl.LoadVariable(k, v: string);
var
   tc,tc_x,tc_y: TControl;
   x,y: string;
   xv,yv: string;
   i: integer;
begin
  tc:=FindControl(k);
  if(tc<>nil) then begin
    SetControlValue(tc,v);
    InitValues.Values[k]:=v;
  end;
end;

procedure TWinStabControl.SetControlValue(tc: TControl; v: string);
begin
  if tc.ClassName='TEdit' then begin
     (tc as TEdit).Text := v;
  end;
  if tc.ClassName='TComboBox' then begin
     (tc as TComboBox).ItemIndex := StrToInt(v);
  end;
  if tc.ClassName='TUpDown' then begin
     (tc as TUpDown).Position := StrToInt(v);
  end;
  if tc.ClassName='TCheckBox' then begin
     if tc.Tag = 0 then begin
       if v='0' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
     end else begin
       if v='1' then  (tc as TCheckBox).Checked:=false else (tc as TCheckBox).Checked:=true;
     end;
  end;
end;


procedure TWinStabControl.BitBtn1Click(Sender: TObject);
begin
  ApplyChanges;
  Close;
end;

procedure TWinStabControl.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TWinStabControl.BitBtn3Click(Sender: TObject);
begin
  ApplyChanges;
end;

end.
